/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables


import cc.cinnamon.canary.users.model.Keys
import cc.cinnamon.canary.users.model.Public
import org.jooq.*
import org.jooq.impl.TableImpl

import javax.annotation.Generated
import java.util.Arrays


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class RolesPermissions private constructor(alias: String, aliased: Table<Record>, parameters: Array<Field<*>>? = null) : TableImpl<Record>(alias, null, aliased, parameters, "") {

    /**
     * The class holding records for this type
     */
    override fun getRecordType(): Class<Record> {
        return Record::class.java
    }

    /**
     * The column `public.roles_permissions.id`.
     */
    val ID = AbstractTable.createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('roles_permissions_id_seq'::regclass)", org.jooq.impl.SQLDataType.BIGINT)), this, "")

    /**
     * The column `public.roles_permissions.role_id`.
     */
    val ROLE_ID = AbstractTable.createField("role_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "")

    /**
     * The column `public.roles_permissions.permission_id`.
     */
    val PERMISSION_ID = AbstractTable.createField("permission_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "")

    /**
     * Create a `public.roles_permissions` table reference
     */
    constructor() : this("roles_permissions", null) {
    }

    /**
     * Create an aliased `public.roles_permissions` table reference
     */
    constructor(alias: String) : this(alias, ROLES_PERMISSIONS) {
    }

    /**
     * {@inheritDoc}
     */
    override fun getSchema(): Schema {
        return Public.PUBLIC
    }

    /**
     * {@inheritDoc}
     */
    override fun getIdentity(): Identity<Record, Long> {
        return Keys.IDENTITY_ROLES_PERMISSIONS
    }

    /**
     * {@inheritDoc}
     */
    override fun getPrimaryKey(): UniqueKey<Record> {
        return Keys.ROLES_PERMISSIONS_PKEY
    }

    /**
     * {@inheritDoc}
     */
    override fun getKeys(): List<UniqueKey<Record>> {
        return Arrays.asList(Keys.ROLES_PERMISSIONS_PKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun getReferences(): List<ForeignKey<Record, *>> {
        return Arrays.asList<ForeignKey<Record, *>>(Keys.ROLES_PERMISSIONS__ROLES_PERMISSIONS_ROLE_ID_FKEY, Keys.ROLES_PERMISSIONS__ROLES_PERMISSIONS_PERMISSION_ID_FKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun `as`(alias: String): RolesPermissions {
        return RolesPermissions(alias, this)
    }

    /**
     * Rename this table
     */
    override fun rename(name: String): RolesPermissions {
        return RolesPermissions(name, null)
    }

    companion object {

        private val serialVersionUID: Long = -1848877979

        /**
         * The reference instance of `public.roles_permissions`
         */
        val ROLES_PERMISSIONS = RolesPermissions()
    }
}
